﻿// Fill out your copyright notice in the Description page of Project Settings.


#include "AC_PlayerDialogueInterpreter.h"


// Sets default values for this component's properties
UAC_PlayerDialogueInterpreter::UAC_PlayerDialogueInterpreter()
{
	// Set this component to be initialized when the game starts, and to be ticked every frame.  You can turn these features
	// off to improve performance if you don't need them.
	PrimaryComponentTick.bCanEverTick = false;

	// ...
}


// Called when the game starts
void UAC_PlayerDialogueInterpreter::BeginPlay()
{
	Super::BeginPlay();

	// ...
}


// Called every frame
void UAC_PlayerDialogueInterpreter::TickComponent(float DeltaTime, ELevelTick TickType, FActorComponentTickFunction* ThisTickFunction)
{
	Super::TickComponent(DeltaTime, TickType, ThisTickFunction);

	// ...
}

void UAC_PlayerDialogueInterpreter::StartDialogue(UDialogueTree* DialogueTree)
{
	CurrentDialogueTree = DialogueTree;
	CurrentTextNode = Cast<UDialogueTextNode>(DialogueTree->RootNodes[0]->ChildrenNodes[0]);
	OnStartDialogue.Broadcast(CurrentTextNode);
}

void UAC_PlayerDialogueInterpreter::NextDialogue()
{
	if (IsValid(CurrentTextNode))
	{
		if (Cast<UDialogueChoiceNode>(CurrentTextNode->ChildrenNodes[0]))
		{
			CurrentTextNode = nullptr;
			CurrentChoiceNode = Cast<UDialogueChoiceNode>(CurrentTextNode->ChildrenNodes[0]);
			OnChoiceDialogue.Broadcast(CurrentChoiceNode);
		}
		else
		{
			CurrentChoiceNode = nullptr;
			CurrentTextNode = Cast<UDialogueTextNode>(CurrentTextNode->ChildrenNodes[0]);
			OnNextDialogue.Broadcast(CurrentTextNode);
		}
	}
}

void UAC_PlayerDialogueInterpreter::MakeChoiceDialogue(const int Choice)
{
	if (Cast<UDialogueChoiceNode>(CurrentTextNode->ChildrenNodes[Choice]))
	{
		CurrentTextNode = nullptr;
		CurrentChoiceNode = Cast<UDialogueChoiceNode>(CurrentTextNode->ChildrenNodes[Choice]);
		OnChoiceDialogue.Broadcast(CurrentChoiceNode);
	}
	else
	{
		CurrentChoiceNode = nullptr;
		CurrentTextNode = Cast<UDialogueTextNode>(CurrentTextNode->ChildrenNodes[Choice]);
		OnNextDialogue.Broadcast(CurrentTextNode);
	}
}
